# This file is a template, and might need editing before it works on your project.
# Select image from https://hub.docker.com/_/php/
image: php:5.6.40

# Select what we should cache between builds (throws an error on Gitlab)
cache:
  paths:
    - vendor/

before_script:
  - apt-get update -yqq
  - DEBIAN_FRONTEND=noninteractive apt-get install -yqq git libmcrypt-dev libpq-dev libcurl4-gnutls-dev libicu-dev libvpx-dev libjpeg-dev libpng-dev libxpm-dev zlib1g-dev libfreetype6-dev libxml2-dev libexpat1-dev libbz2-dev libgmp3-dev libldap2-dev unixodbc-dev libsqlite3-dev libaspell-dev libsnmp-dev libpcre3-dev libtidy-dev libmagickwand-dev
  # - rm -rf /var/lib/apt/lists/*
  # - apt-get update
  # - apt-cache gencaches
  # Install PHP extensions
  - docker-php-ext-install mbstring mcrypt pdo_mysql pdo_pgsql curl json intl gd xml zip bz2 opcache
  # Install & enable ImageMagick
  - pecl install imagick
  - docker-php-ext-enable imagick
  # Install & enable Xdebug for code coverage reports (PHP >= 7.2)
  # - pecl install xdebug
  # - docker-php-ext-enable xdebug
  # Install and run Composer
  - curl -sS https://getcomposer.org/installer | php
  # - php composer.phar install
  - php composer.phar update
  - chmod +x ./tests/bin/yii
  - ./tests/bin/yii migrate/fresh --interactive=0

# Bring in any services we need http://docs.gitlab.com/ee/ci/docker/using_docker_images.html#what-is-a-service
# See http://docs.gitlab.com/ee/ci/services/README.html for examples.
services:
  - mysql:5.7

# Set any variables we need
variables:
    # Configure mysql environment variables (https://hub.docker.com/r/_/mysql/)
  MYSQL_DATABASE: "todo_test"
  MYSQL_ROOT_PASSWORD: ""
  MYSQL_ALLOW_EMPTY_PASSWORD: "yes"
  # DOCKER_TLS_CERTDIR: ""

# Define Stages
stages:
  - build
  - test

# Run our tests
# If Xdebug was installed you can generate a coverage report and see code coverage metrics.
build:
  stage: build
  script:
    - chmod +x ./vendor/bin/codecept
    - ./vendor/bin/codecept build
  artifacts:
    paths:
    - tests/_support
    - tests/_support/_generated

test:
  stage: test
  dependencies:
    - build
  script:
    - chmod +x ./tests/bin/yii
    - ./tests/bin/yii serve &
    - ./vendor/bin/codecept run
